#! /usr/bin/perl
# (C) 1999 Michael Weber <Michael.Weber@Post.RWTH-AAchen.DE>
#

use Pg;
use Time::localtime;
use POSIX floor;
use CGI qw/:standard/,qw/:html/;

my ($dbname) = "maks_db";
my ($user)   = "chrisb";
my ($conn);


###################################################################
sub tt {
	return ("<TT>@_</TT>");
}

print
	header,"\n",
	start_html (-title=>"Euracom Gebhren",
                    -BGCOLOR=>"white"), "\n",
        h1 ('Geb&uuml;hren-Auswertung'), "\n";

        my ($today) = localtime ();
        print startform (),
              "MSN: ", textfield ('msn'), br, "\n",
              "Zeitraum von: ", textfield (-name=>'date_from',
                                           -default=>sprintf("%02d.%02d.%04d", $today->mday, $today->mon+1, 1900+$today->year)), 
              " bis ", textfield ('date_to'), br, "\n",
              checkbox_group (-name=>'direction',
                              -values=>[In,Out],
                              -linebreak=>'yes',
                              -defaults=>[In,Out]), br, "\n",
              submit ('Action', 'Auswerten'), br, "\n",
              endform, "\n",
              hr, "\n";

if (!param) { exit 0;x }

$conn = Pg::connectdb ("dbname=$dbname user=$user");

if ($conn->status == PGRES_CONNECTION_OK) {
        
        my (@restrict) = "";
        my ($param_date_from);
        my ($param_date_to);
        my (@direction) = param ('direction');

        if (param ('date_from')) {
                $param_date_from = param ('date_from');
                if (param ('date_to')) {
                        $param_date_to = param ('date_to');
                } else {
                        $param_date_to = $param_date_from;
                }
                push (@restrict, "p_date BETWEEN '$param_date_from' AND '$param_date_to'");
        }

        push (@restrict, "m_msn=" . param ('msn') ) if param ('msn');

        if (grep (/^In$/, @direction)) {
                if (!grep (/^Out$/, @direction)) {
                        push (@restrict, "p_io=1");
                }
        } elsif (grep (/^Out$/, @direction)) {
                push (@restrict, "p_io=0");
        }
        
        $conn->exec ("SET DateStyle TO 'german'");
	$result = $conn->exec ("SELECT p_io, p_date, p_time, p_number, p_xtend, x_name, m_msn, m_name, p_duration, p_costs FROM calls, port, xtend WHERE p_xtend = x_number AND p_port = m_port AND p_msn = m_idx " . join (" AND ", @restrict) . " ORDER BY p_date, p_time");
	my ($sum) = 0;
	print qq+<center><table bgcolor="#CCCCFF" border="0" cellspacing="2" cellpadding="4">\n+;
	print TR ({bgcolor=>"lightgreen"},
		td ({align=>"center"}, "Datum"),
		td ({align=>"center"}, "Zeit"),
		td ({align=>"center"}, "Dauer"),
		td ({align=>"center"}, "&nbsp;"),
		td ({align=>"center"}, "&nbsp;"),
		td ({align=>"center"}, "Nebenstelle"),
		td ({align=>"center"}, "Besitzer"),
		td ({align=>"center"}, "Betrag") ), "\n";
	while (@row = $result->fetchrow) {
		#printf "%s\n", join ("|", @row);
		($io, $date, $time, $from, $nst, $nst_name, $msn, $msn_name, $duration, $costs) = @row;
		$dur = sprintf ("%02d:%02d:%02d", floor ($duration / 3600), floor ($duration / 60) % 60, $duration % 60 );
		$sum += $costs;
		print TR ($io ? {bgcolor=>"#CCCCDD"} : {},
		        td ({align=>"center"}, tt ($date) ), 
			td ({align=>"center"}, tt ($time) ),
			td ({align=>"center"}, tt ($dur) ),
			td ({align=>"right"}, tt ($from) ),
			td ({align=>"center"}, tt ($io ? "-&gt;" : "&lt;-") ),
			td ({align=>"left"}, tt ($nst_name) ),
			td ({align=>"center"}, $nst_name eq $msn_name ? "" : tt ($msn_name) ),
			td ({align=>"right"},  $io ? "&nbsp;" : tt (sprintf ("%2.2f DM", $costs)) ) ),"\n";
	}
	print TR ( 
	        td (""), 
		td (""),
		td (""),
		td (""),
		td (""),
		td (""),
		td ({bgcolor=>"red", align=>"right"}, b ("Summe:") ),
		td ({bgcolor=>"red", align=>"right"}, b (tt (sprintf ("%2.2f DM", $sum))) ) ),"\n";

        print qq+</table></center>\n+;

} else {
	print "Could not connect to database", "\n";
}

print end_html, "\n";

### Local Variables:
### cperl-indent-level: 8
### End:

