/********************************************************************
 * Gabi/auswert.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: auswert.h,v 1.3 1999/03/01 20:52:14 root Exp $
 *
 ********************************************************************/

#ifndef __AUSWERT_H__
#define __AUSWERT_H__

typedef struct V3OCalls {
	LONG	Gebuehr1  : 8;
	LONG	Gebuehr2  : 8;
	LONG	Gebuehr3  : 8;
	LONG	Appnum    : 8;
	LONG	Dauer     : 16;
	LONG	Dauer1    : 4;
	LONG	Year      : 8;
	LONG	Month     : 4;
	LONG	Day       : 5;
	LONG	Hour      : 5;
	LONG	Minute    : 6;
	LONG	Port      : 2;
	LONG	Msn       : 4;
	LONG	Grp       : 10;
	BYTE	Nummer[12];
} V3OCallsType;

#define NoConnect		0xAA
#define AnalogCaller	0xFF

typedef struct ICalls {
	BYTE  LLFVal      __attribute__ ((packed));
	BYTE  LHFVal      __attribute__ ((packed));
	BYTE  HLFVal      __attribute__ ((packed));
	BYTE  HHFVal      __attribute__ ((packed));
	WORD  Dauer       __attribute__ ((packed));
	BYTE  Appnum      __attribute__ ((packed)); /* BCD; 0xAA n.a.*/
	BYTE  Nummer[12]  __attribute__ ((packed)); /* BCD; 0xFF Analog*/
} InCallsType;

void	showOutCalls(FILE *fp, BYTE *data, int cnt);
void	showInCalls(FILE *fp,InCallsType icp[], int cnt);
int	handle_outcalls(FILE *fp, EspMsg  *esp);
int	handle_incalls(FILE *fp, EspMsg  *esp);
void	RequestData();
void	do_delete_calls();

#endif  __AUSWERT_H__
