/********************************************************************
 * Gabi/handle.c
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: handle.c,v 1.4 1999/03/01 20:52:14 root Exp $
 *
 ********************************************************************/
#include <sys/types.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include <config.h>
#include <maKs.h>
#include <Packet.h>
#include <Decode.h>
#include <server_conn.h>

#include "auswert.h"
#include "handle.h"

extern float	fw_version;
extern int		m_sock;
extern int		done;
extern FILE		*outf;

/********************************************************************
 * Handle ESP group commands
 ********************************************************************/
int handle_CTI_ESP(int fd, EspMsg  *esp)
{
	switch(esp->element) {
		case ESP_CONN_REQ :
			if (!S_CTI_ERR(esp->gruppe)) {
				if (esp->data[0] == AUTH_DENY) {
					fprintf(stderr,"Login denied! %s\n", (esp->length > 1) ? (char *)&esp->data[1] : "");
					exit(1);
				} else if (esp->data[0] == AUTH_CLEARTXT) {
					conn_auth_cleartext(fd, get_user(),get_passwd(), ASYNC);
				} else if (esp->data[0] == 0) {
					done = 100;
				} else {
					fprintf(stderr,"Login denied! %s\n", (esp->length > 1) ? (char *)&esp->data[0] : "");
					exit(1);
				}
			}
			return(HANDLED);
			break;
		case ESP_CONN_AUTH :
			if (!S_CTI_ERR(esp->gruppe)) {
				done = 100;
			} else {
				fprintf(stderr,"Wrong authorization method!\n");
				exit(1);
			}
			return(HANDLED);
			break;
	}
	return(NOT_HANDLED);
}

