/********************************************************************
 * RiKe/AFrame.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: AFrame.h,v 1.1 1999/12/30 20:56:45 root Exp root $
 *
 ********************************************************************/

#include <qlistview.h> 
#include <qbitarray.h>
#include <kprocess.h>
#include <MsgHandlerQt.h>

//class AFrame : public QFrame {
class AFrame : public KTopLevelWidget  {
	
	Q_OBJECT

public:
	//AFrame(QWidget *_parent=0L, const char *name=0L);
	AFrame(const char *name=0L);
	~AFrame();

public slots:
	void	start(ESPMsgHdr *);
	void	Handle_ESP(ESPMsgHdr *);
	void	failure(MsgHandler*);

protected slots:
	void	dial();
	void	deleteSel();
	void	insertSel();
	void	editSel();
	void	moveSel();
	void	editSel(QListViewItem *); 
	void	printList();
	void	loadList();
	void	saveList();
	void	programList();
	void	programEntry();
	void	checkSel();
	void	find();
	void	find_next();
	void	dopop(QListViewItem*,const QPoint &, int);
	void	setSel(QListViewItem *); 
	void	endPrint(KProcess *);
	void	logon_timeout();

private:
	void	logon();
	void	build();
	void	readtlb(QString&);
	void	fileformat(QTextStream&);
	void	clearUseBits();
	int		findUnused();
	int		findUnused(int);
	void	find(QListViewItem *, const char * = 0L);
	bool	sendEntry(QListViewItem *);
	void	haveData(bool);
	void	haveConn(bool);
	void	haveSel(bool);

	KMenuBar	*mbar;
	QPopupMenu	*datei;
	QPopupMenu	*anlage;
	QPopupMenu	*eintrag;

	int			saveID;
	int			dialID;
	int			loadID;
	int			progID;
	int			sendID;
	int			findID;
	int			fndnID;
	int			editID;
	int			moveID;
	int			deleID;
	int			insrID;
	int			prntID;
	int			quitID;
	

	QTimer		logontimer;
	QString		__okz__;
	QString		__lkz__;
	QListViewItem	*sel;
	QListView	*list;
	QBitArray	*kwzuse;
	MsgHandlerQt  *mh;
};
