#include <Dialer.moc>

extern KConfig *kConf;

/***************************************************************
 * Show Login-Dialog
 ***************************************************************/
Dialer::Dialer(MsgHandlerQt *mh, QWidget* _parent, const char* _name, bool _modal, WFlags _f) 
	: QDialog(_parent, _name, _modal, _f)
{
	msghndl = mh;

	frame = new QFrame(this);
	frame->setLineWidth(0);
	frame->move(5,5);

	frame1 = new QFrame(frame);
	frame1->setFrameStyle(QFrame::Panel | QFrame::Sunken);
	frame1->setLineWidth(1);
	frame1->move(5,5);

	nstL = new QLabel("Nebenstelle:",frame1);
	nstL->setAlignment(AlignLeft);
	nstL->resize(90,20);
	nstL->move(5, 5);

	nstB = new KCombo(false, frame1);
	nstB->resize(90,25);
	nstB->move(5, nstL->frameGeometry().bottom() + 5);

	msnL = new QLabel("Gehende MSN:",frame1);
	msnL->setAlignment(AlignLeft);
	msnL->resize(90,20);
	msnL->move(5, nstB->frameGeometry().bottom() + 8);

	msnB = new KCombo(false, frame1);
	msnB->resize(90,25);
	msnB->move(5, msnL->frameGeometry().bottom() + 5);

	frame1->resize(nstL->width() + 10, msnB->frameGeometry().bottom() + 5);


	frame2 = new QFrame(frame);
	frame2->setFrameStyle(QFrame::Panel | QFrame::Sunken);
	frame2->setLineWidth(1);
	frame2->move(frame1->frameGeometry().right() +5 ,5);
	frame2->resize(300,300);

	numL = new QLabel("Waehlen:",frame2);
	numL->setAlignment(AlignLeft);
	numL->resize(90,20);
	numL->move(5, 8);

	numE = new QLineEdit(frame2);
	numE->move(5, numL->frameGeometry().bottom() + 5);
	numE->resize(frame2->width() - 10, 20);

	t1 = new KKeyButton("1",frame2);
	t1->move(5, numE->frameGeometry().bottom() + 10);
	t1->resize(25,25);
	t1->setText("1");
	t2 = new KKeyButton("2",frame2);
	t2->move(t1->frameGeometry().right(), numE->frameGeometry().bottom() + 10);
	t2->resize(25,25);
	t2->setText("2");
	t3 = new KKeyButton("3",frame2);
	t3->move(t2->frameGeometry().right(), numE->frameGeometry().bottom() + 10);
	t3->resize(25,25);
	t3->setText("3");
	t4 = new KKeyButton("4",frame2);
	t4->move(5, t1->frameGeometry().bottom());
	t4->resize(25,25);
	t4->setText("4");
	t5 = new KKeyButton("5",frame2);
	t5->move(t4->frameGeometry().right(), t1->frameGeometry().bottom());
	t5->resize(25,25);
	t5->setText("5");
	t6 = new KKeyButton("6",frame2);
	t6->move(t5->frameGeometry().right(), t1->frameGeometry().bottom());
	t6->resize(25,25);
	t6->setText("6");

	okB = new QPushButton("OK", frame);
	okB->resize(80,20);

	cancelB = new QPushButton("Abbrechen", frame);
	cancelB->resize(80,20);

	okB->move(frame1->frameGeometry().left() + 8, frame1->frameGeometry().bottom() + 8);
	
	cancelB->move(frame2->frameGeometry().right() - 8 - cancelB->width(), frame2->frameGeometry().bottom() + 8);

	frame->resize(frame2->frameGeometry().right() + 5, cancelB->frameGeometry().bottom() + 8);

	okB->setDefault(true);

	QObject::connect(okB,		SIGNAL(clicked()), SLOT(accept()));
	QObject::connect(cancelB,	SIGNAL(clicked()), SLOT(reject()));
	QObject::connect(nstB,	SIGNAL(activated(int)), SLOT(nst_slot(int)));
	QObject::connect(msnB,	SIGNAL(activated(int)), SLOT(msn_slot(int)));

	GetPBXInfo();

/*
	kConf = KApplication::getKApplication()->getConfig();
	kConf->setGroup(KApplication::getKApplication()->appName());
	readPrefs();
*/


}

/***************************************************************
 * Free Space
 ***************************************************************/
Dialer::~Dialer()
{
	//writePrefs();
}

void Dialer::nst_slot(int i)
{
	vector<BYTE>::iterator x = nstref.begin() + i;
	cout << hex << (int)(*x) << dec << endl;
}

void Dialer::msn_slot(int i)
{
	vector<BYTE>::iterator x = msnref.begin() + i;
	cout << hex << (int)(*x) << dec << endl;
}

void Dialer::readPrefs()
{
/*
	__regx = strdup(kConf->readEntry("REGEX", "[a-zA-Z]*").data());
	regxE->setText(__regx);

*/
}

void Dialer::writePrefs()
{
/*
	if (result() == Accepted) {
		kConf->writeEntry("REGEX", regxE->text());
	}
*/
}

bool Dialer::GetPBXInfo() {
	msghndl->switchDebug(true);
	{
		ESPMsgHdr ep = msghndl->syncSend(MsgHandlerQt::G_ANL, MsgHandlerQt::ANL_MAX_PARA);
		if ((ep.gruppe & K_CTI_ERR) != K_CTI_ERR) {
			pbx1.setMaxParm(ep.data);
		} else 
			return false;
	}

	{
		ESPMsgHdr ep = msghndl->syncSend(MsgHandlerQt::G_ANL, MsgHandlerQt::ANL_TYP);
		if ((ep.gruppe & K_CTI_ERR) != K_CTI_ERR) {
			pbx1.setTyp(ep.data);
		} else 
			return false;
	}

	{
		ESPMsgHdr ep = msghndl->syncSend(MsgHandlerQt::G_ANL, MsgHandlerQt::ANL_BETRIEBSART);
		if ((ep.gruppe & K_CTI_ERR) != K_CTI_ERR) {
			pbx1.setBArt(ep.data[0]);
		} else 
			return false;
	}

	{
		ESPMsgHdr ep = msghndl->syncSend(MsgHandlerQt::G_ANL, MsgHandlerQt::ANL_SW_VERSION);
		if ((ep.gruppe & K_CTI_ERR) != K_CTI_ERR) {
			pbx1.setSWVers(ep.data);
		} else 
			return false;
	}

	cout << pbx1 << endl;


#define CTI_S0_PORT_DIR_EXTERN 0x40
#define CTI_S0_PORT 0x40

	for (BYTE index = 0; index < pbx1.S0Sum() ; index++) {
		vector<BYTE> vec(2);
		vec[0] = CTI_S0_PORT;
		vec[1] = index;
		ESPMsgHdr ep = msghndl->syncSend(MsgHandlerQt::G_POR, MsgHandlerQt::POR_MODE,vec);
		if ((ep.gruppe & K_CTI_ERR) != K_CTI_ERR) {
			if (ep.data[2] & CTI_S0_PORT_DIR_EXTERN) 
				for (BYTE msnidx = 0; msnidx < 10; msnidx++) {
					vector<BYTE> info(3);
					info[0] = CTI_S0_PORT;
					info[1] = index;
					info[2] = msnidx;
					ESPMsgHdr msnep = msghndl->syncSend(MsgHandlerQt::G_POR, MsgHandlerQt::POR_AMT_RNR,info);
					if ((msnep.gruppe & K_CTI_ERR) != K_CTI_ERR) {
						BaseNumber msn_phone(vector<BYTE>(msnep.data.begin() + 6, msnep.data.end()));
						msnB->insertItem(msn_phone.Phone().c_str());
						msnref.push_back(((index << 4) + msnidx)); //Save index for dialing
						cout << msn_phone.Phone().c_str() << " : " << msn_phone.Phone() ;
						cout << hex << " idx: " << (int)((index << 4) + msnidx) << dec << endl;
						
					} else 
					return false;
				}
		} else 
			return false;
	}

	for (BYTE index = 0; index < 3; index++) {
		ESPMsgHdr ep = msghndl->syncSend(MsgHandlerQt::G_ANL, MsgHandlerQt::ANL_TLN_INFO,index);
		if ((ep.gruppe & K_CTI_ERR) != K_CTI_ERR) {
			int n = (int)(ep.data.size() / 6);
			for (int i = 0; i < n; i++) {
				if ((ep.data[(i * 6) + 4] != 0xFF)) {
					TlnInfo dummy((char*)&ep.data[(i * 6) + 0]);
					if (
						((dummy.Untertyp() == TlnInfo::Telefon) || (dummy.Untertyp() == TlnInfo::Multi)) &&
						((dummy.Typ() == TlnInfo::S0Intern) || (dummy.Typ() == TlnInfo::Analog))
					) {
						nstB->insertItem(dummy.Nummer());
						nstref.push_back(ep.data[(i * 6) + 4]); // Save BCD number of extension
					} else
						cout << dummy.Typ() << " " << dummy.Untertyp() << endl;
					cout << dummy << endl;
				}
			}
		} else
			return false;
	}
	msghndl->switchDebug(false);
	return true;
}

