/********************************************************************
 * EditD.cpp
 * Part of maKs
 * Copyright Chris Benndorf, 1998, 1999, 2000
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: EditD.cpp,v 1.1 1999/12/30 20:56:45 root Exp root $
 *
 ********************************************************************/

#include <qdialog.h>
#include <qframe.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qstring.h>
#include "EditD.moc"

/***************************************************************
 * Show Edit-Dialog
 ***************************************************************/
EditDialog::EditDialog(QWidget* _parent=0, const char* _name=0, bool _modal=true, WFlags _f=0) 
	: QDialog(_parent, _name, _modal, _f)
{
	setCaption(_name);
	frame = new QFrame(this);
	nameL = new QLabel("Name:",frame);
	nameE = new QLineEdit(frame);
//	kwzL  = new QLabel("Kurzwahl:",frame);
//	kwzE  = new QLineEdit(frame);
	lkzL  = new QLabel("Land:",frame);
	lkzE  = new QLineEdit(frame);
	okzL  = new QLabel("Ort:",frame);
	okzE  = new QLineEdit(frame);
	telL  = new QLabel("Nummer:",frame);
	telE  = new QLineEdit(frame);
	grpL  = new QLabel("Gruppe:",frame);
	grpE  = new QLineEdit(frame);
	okB = new QPushButton("OK", this);
	cancelB = new QPushButton("Abbrechen", this);


	frame->setFrameStyle(QFrame::Panel | QFrame::Sunken);
	frame->setLineWidth(1);
	nameL->setAlignment(AlignLeft);
	lkzL->setAlignment(AlignLeft);
	okzL->setAlignment(AlignLeft);
	telL->setAlignment(AlignLeft);
	grpL->setAlignment(AlignLeft);
//	kwzL->setAlignment(AlignLeft);

	nameE->setMaxLength(40);
	lkzE->setMaxLength(5);
	okzE->setMaxLength(5);
	telE->setMaxLength(20);
	grpE->setMaxLength(2);

	nameL->resize(50,20);
	lkzL->resize(50,20);
	okzL->resize(50,20);
	telL->resize(50,20);
	grpL->resize(50,20);
//	kwzL->resize(50,20);
	okB->resize(80,20);
	cancelB->resize(80,20);

	frame->move(5,5);
	frame->resize(300,150);

	nameL->move(5, 5);

	nameE->move(nameL->frameGeometry().right() + 5, 5);
	nameE->resize(frame->width() - 65, 20);

//	kwzL->move(5, nameE->frameGeometry().bottom() + 5);

//	kwzE->move(kwzL->frameGeometry().right() + 5, nameE->frameGeometry().bottom() + 5);
//	kwzE->resize(nameE->width() ,nameE->height());

	lkzL->move(5, nameE->frameGeometry().bottom() + 8);

	lkzE->move(lkzL->frameGeometry().right() + 5, nameE->frameGeometry().bottom() + 5);
	lkzE->resize(nameE->width() ,nameE->height());

	okzL->move(5, lkzE->frameGeometry().bottom() + 8);

	okzE->move(okzL->frameGeometry().right() + 5, lkzE->frameGeometry().bottom() + 5);
	okzE->resize(nameE->width() ,nameE->height());

	telL->move(5, okzE->frameGeometry().bottom() + 8);

	telE->move(telL->frameGeometry().right() + 5, okzE->frameGeometry().bottom() + 5);
	telE->resize(nameE->width() ,nameE->height());

	grpL->move(5, telE->frameGeometry().bottom() + 8);

	grpE->move(grpL->frameGeometry().right() + 5, telE->frameGeometry().bottom() + 5);
	grpE->resize(nameE->width() ,nameE->height());

	frame->resize(300, grpE->frameGeometry().bottom() + 5);

	okB->move(frame->frameGeometry().left() + 8, frame->frameGeometry().bottom() + 8);
	
	cancelB->move(frame->frameGeometry().right() - 8 - cancelB->width(), frame->frameGeometry().bottom() + 8);

	resize(frame->width() + 10, cancelB->frameGeometry().bottom() + 8);

	okB->setDefault(true);
	QObject::connect(okB,     SIGNAL(clicked()), SLOT(saveData()));
	QObject::connect(cancelB, SIGNAL(clicked()), SLOT(reject()));

}

/***************************************************************
 * Free Space
 ***************************************************************/
EditDialog::~EditDialog()
{
	
}

void EditDialog::saveData()
{
	__name = nameE->text();
//	__kwz  = kwzE->text();
	__okz  = okzE->text();
	__lkz  = lkzE->text();
	__tel  = telE->text();
	__grp  = grpE->text();

	accept();
}

void EditDialog::SetData(const QString& n,const QString& k, const QString& l,const QString& o,const QString& t,const QString& g) {
	nameE->setText(n);
	__kwz = k; // kwzE->setText(k);
	lkzE->setText(l);
	okzE->setText(o);
	telE->setText(t);
	grpE->setText(g);
}

void EditDialog::SetData(const char* n,const char* k, const char* l,const char* o,const char* t,const char* g) {
	nameE->setText(n);
	__kwz = k; // kwzE->setText(k);
	lkzE->setText(l);
	okzE->setText(o);
	telE->setText(t);
	grpE->setText(g);
}

const QString& EditDialog::Name()
{
	return(__name);
}

const QString& EditDialog::Kurzwahl()
{
	return(__kwz);
}

const QString& EditDialog::Gruppe()
{
	return(__grp);
}

const QString& EditDialog::Okz()
{
	return(__okz);
}

const QString& EditDialog::Lkz()
{
	return(__lkz);
}

const QString& EditDialog::Telnr()
{
	return(__tel);
}

