/********************************************************************
 * Rike/kwz.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: kwz.c,v 1.3 1999/12/30 20:57:53 root Exp root $
 *
 ********************************************************************/

#include <stdio.h>
#include <string.h>

#include <maKs.h>
#include <Decode.h>

#include "kwz.h"

extern int	debug;

kwzentry	kwzarray[200];
int			satz = 0;

/********************************************************************
 *
 ********************************************************************/
void initEntries()
{
	int i;

	for (i=0; i < 200; i++) {
		kwzarray[i].len = 0;
		memset(kwzarray[i].entry,0,MAXNUMLEN);
		kwzarray[i].len = 9 + 5;
		kwzarray[i].entry[0]= 0x03;
		kwzarray[i].entry[1]= 0x00;
		kwzarray[i].entry[2]= 0x00;
		kwzarray[i].entry[3]= (BYTE)(i & 0x00FF);
		kwzarray[i].entry[4]= 0;
		strcpy(kwzarray[i].name, "--- leer ---");
	}
}

/********************************************************************
 *
 ********************************************************************/
void storeEntry(int kwz, char *lkz, char *okz, char *num, char *name)
{
	char *cvtnum;
	char wahl[MAXNUMLEN];
	int  len;

	sprintf(wahl,"%s%s%s",(strcmp(lkz,"0049") ? lkz : "0"), okz,num);

	if (debug)
		printf("Eintrag %d: %s, %s\n",kwz,name,wahl);

	cvtnum = set_Phonenumber(wahl,&len);

	kwzarray[kwz].len = len + 9 + 5;
	kwzarray[kwz].entry[0]= 0x03;
	kwzarray[kwz].entry[1]= 0x00;
	kwzarray[kwz].entry[2]= 0x00;
	kwzarray[kwz].entry[3]= (BYTE)(kwz & 0x00FF);
	kwzarray[kwz].entry[4]= (BYTE)(len & 0x00FF);

	memcpy(&kwzarray[kwz].entry[5], cvtnum, len);
	strncpy(kwzarray[kwz].name, name, 29);
}

/********************************************************************
 *
 ********************************************************************/
void ReadTBook(char *tbook)
{
	FILE *tfp;
	char buf[BUFFSIZE];
	char *tp;
	char *tok;
	char *name;
	char *lkz;
	char *okz;
	char *num;
	int  kwz;

	if ((tfp = fopen(tbook,"r")) == NULL) {
		perror(tbook);
		exit(1);
	}

	initEntries();

	while (fgets(buf,BUFFSIZE,tfp)) {
		tp = buf;
		if ((buf[0] != '[') && (buf[0]!='#')) {
			tok = strsep(&tp,";");
			name = tok;
			tok = strsep(&tp,";");
			lkz = tok;
			tok = strsep(&tp,";");
			okz = tok;
			tok = strsep(&tp,";");
			num = tok;
			tok = strsep(&tp,";");
			kwz = atoi(tok);
			/* Gruppe */
			tok = strsep(&tp,";");
			
			if (kwz > 99 && kwz < 300) {
				storeEntry(kwz - 100, lkz, okz, num, name);
			}
		}
	}

	fclose(tfp);
}

/********************************************************************
 *
 ********************************************************************/
int get_next_kwz(BYTE **data, int *len)
{
	BYTE *leer = "\0";

	while ((satz <= 199) && (!kwzarray[satz].len)) {
		satz++;
	}

	if ((satz <= 199) && (kwzarray[satz].len)) {
		printf("Schreibe KWZ %d: %s\n",satz + 100, kwzarray[satz].name);
		*data = kwzarray[satz].entry;
		*len = kwzarray[satz].len;
		satz++;
		return(0);
	} else {
		*data = NULL;
		*len = 0;
		return(1);
	}
}

