#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <errno.h>
#include <time.h>

#include <glob.h>

FILE	*logfp;
int		debug = 0;

int  logOK(int level)
{
	return((debug & level) == level);
}

void logdate(int level)
{
	time_t the_t;

	if ((debug & level) != level) return;

	the_t = time(0L);
	fprintf(logfp,"\n%s",ctime(&the_t));
}

void logerror(const char *fmt, ...)
{
	va_list ap;

	fprintf(logfp,"%s:",sys_errlist[errno]);

	va_start(ap, fmt);
	vfprintf(logfp, fmt, ap);
	va_end(ap);

	fprintf(logfp,"\n");
    fflush(logfp);
}

void logprintf(int level, const char *fmt, ...)
{
	va_list ap;

	if ((debug & level) != level) return;
	
	va_start(ap, fmt);
	vfprintf(logfp, fmt, ap);
	va_end(ap);

    fflush(logfp);
}

void logbuf(int level, char *where, BYTE *buf, int len)
{
	BYTE *save = buf;
	int llen;
	int c;

	if ((debug & level) != level) return;

    fprintf(logfp, "%s:\t", where);
    for (llen = len ; llen ; llen-- ) {
        fprintf(logfp, "%02X ", *buf++);
    }
    fprintf(logfp,"\n");

    fprintf(logfp, "%s:\t", where);
    for (llen = len ; llen ; llen-- ) {
		c = (int)(*save++);
        fprintf(logfp, "%c  ", (isprint(c)) ? c : '.');
    }
    fprintf(logfp,"\n");

    fflush(logfp);
}
