dnl
dnl Check for postgres
dnl


AC_DEFUN(AC_CHECK_QT_KDE, [
	qt_inc="no"
	qt_lib="no"
	qt_inc_search="/usr/lib/qt/include /usr/X11/lib/qt/include /usr/X11R6/include/qt /usr/local/qt/include"
	qt_lib_search="/usr/lib /usr/lib/qt /usr/lib/qt/lib /usr/X11/lib/qt/lib /usr/X11R6/lib /usr/X11R6/qt/lib /usr/local/qt/lib" 

	AC_ARG_WITH(qt-lib,
                [  --with-qt-lib=DIR     Set Qt lib directory []],
                tst_qt_lib_dir="${withval}")

	AC_ARG_WITH(qt-inc,
                [  --with-qt-inc=DIR     Set Qt include directory []],
                tst_qt_inc_dir="${withval}")

	if test "${tst_qt_inc_dir}" != "yes" && test "${tst_qt_inc_dir}" != ""; then
		AC_MSG_CHECKING([for Qt includes in ${tst_qt_inc_dir}/qapp.h])
		AC_EGREP_HEADER(QApplication,${tst_qt_inc_dir}/qapp.h,
		qt_inc=${tst_qt_inc_dir})
		if test "$qt_inc" != "no"; then
			AC_MSG_RESULT("yes")
		else
			AC_MSG_RESULT("no")
		fi
	fi

	if test "${tst_qt_lib_dir}" != "yes" && test "${tst_qt_lib_dir}" != ""; then
		AC_MSG_CHECKING([for Qt Libraries in ${tst_qt_lib_dir}])
		AC_CHECK_LIB(qt, main, qt_lib=${tst_qt_lib_dir}, qt_lib=no, [-L${tst_qt_lib_dir}])
		if test "$qt_lib" != "no"; then
			AC_MSG_RESULT("yes")
		else
			AC_MSG_RESULT("no")
		fi
	fi

	if test "${qt_lib}" = "no"; then
		AC_MSG_CHECKING([for Qt Libraries in default setup])
                unset ac_cv_lib_qt_main
		AC_CHECK_LIB(qt, main, qt_lib=)
	fi

	if test "${qt_inc}" = "no"; then
		for tst_qt_dir in ${qt_inc_search} ; do
			if test "${qt_inc}" = "no"; then
				AC_MSG_CHECKING([for Qt includes in ${tst_qt_dir}/qapp.h])
				AC_EGREP_HEADER(QApplication,${tst_qt_dir}/qapp.h,
				qt_inc=${tst_qt_dir})
				if test "$qt_inc" != "no"; then
					AC_MSG_RESULT("yes")
					continue
				else
					AC_MSG_RESULT("no")
				fi
			fi
		done
	fi

	if test "${qt_lib}" = "no"; then
		for tst_qt_dir in ${qt_lib_search} ; do
			if test "${qt_lib}" = "no"; then
				AC_MSG_CHECKING([for Qt Libraries in ${tst_qt_dir}])
                                unset ac_cv_lib_qt_main
				AC_CHECK_LIB(qt, main, qt_lib=${tst_qt_dir}, qt_lib=no, [-L${tst_qt_dir}])
				if test "$qt_lib" != "no"; then
					continue
				fi
			fi
		done
	fi

	if test "$qt_lib" != "no" ; then
		QT_LIB=${qt_lib}
		AC_SUBST(QT_LIB)
	else
		AC_CHECK_LIB(qt, main, , AC_MSG_RESULT("Qt-Lib-Dir not found. Run \"configure --with-qtlib=DIR\"") )
		QT_LIB=""
		AC_SUBST(QT_LIB)
	fi

	if test "$qt_inc" != "no" ; then
		QT_INC="$qt_inc"
		AC_SUBST(QT_INC)
 		AC_CHECK_KDE
	else
		AC_MSG_RESULT("Qt-Include-Dir not found. Run \"configure --with-qtinc=DIR\"")
		QT_INC=""
		KDE_DIR=""
		AC_SUBST(QT_INC)
		AC_SUBST(KDE_DIR)
		
	fi

	AC_PATH_PROG(QT_MOC, moc, /usr/bin/moc, $PATH:/usr/lib/qt:/usr/local/qt)

])

AC_DEFUN(AC_CHECK_POSTGRES, [
	tst_postgres=1
	POSTGRESDIR=""
	pqdir="no"
	post_search=" /lib/postgres95 /lib/pgsql /usr/lib/postgres95 /usr/lib/pgsql /usr/local/postgres95 /usr/local/pgsql /usr/local/lib/postgres95 /usr/local/lib/pgsql /opt/postgres95 /opt/pgsql"

	AC_ARG_WITH(postgres,
                [  --without-postgres     Set postgres directory []],
                tst_postgres=0)

	AC_ARG_WITH(postgres,
                [  --with-postgres=DIR     Set postgres directory []],
                tst_postgresdir="${withval}")

	if test "$tst_postgres" -eq 1 ; then

		if test "${tst_postgresdir}" != "yes" && test "${tst_postgresdir}" != ""; then
			AC_MSG_CHECKING([for postgres in ${tst_postgresdir}])
			AC_EGREP_HEADER(PGconn,${tst_postgresdir}/include/libpq-fe.h,
			pqdir=${tst_postgresdir})
			if test "$pqdir" != "no"; then
				AC_MSG_RESULT("yes")
			else
				AC_MSG_RESULT("no")
			fi
		fi
	
		if test "$pqdir" = "no" ; then
			for tst_postgresdir in ${post_search} ; do
				if test "$pqdir" = "no" ; then
					AC_MSG_CHECKING([for POSTGRES in ${tst_postgresdir}])
					AC_EGREP_HEADER(PGconn,${tst_postgresdir}/include/libpq-fe.h,
					pqdir=${tst_postgresdir})
					if test "$pqdir" != "no"; then
						AC_MSG_RESULT("yes")
						continue
					else
						AC_MSG_RESULT("no")
					fi
				fi
			done
		fi
	
		if test "$pqdir" != "no" ; then
			POSTGRES=1
			AC_DEFINE_UNQUOTED(POSTGRES,1)
		else
			AC_MSG_RESULT("Postgres not found. Run \"configure --with-postgres=DIR\"")
			AC_MSG_RESULT("USE OF POSTGRES DISABLED")
			pqdir=""
		fi
		POSTGRES_DIR="$pqdir"
		AC_DEFINE_UNQUOTED(POSTGRES_DIR,"$pqdir")
		AC_SUBST(POSTGRES_DIR)
	else
		POSTGRES_DIR=""
		AC_DEFINE_UNQUOTED(POSTGRES_DIR,"")
		AC_SUBST(POSTGRES_DIR)
	fi
])

AC_DEFUN(AC_CHECK_KDE, [
	KDE_DIR=""
	kde_dir="no"
	kde_search="/opt/kde /usr/kde /usr/X11/kde/include /usr/X11R6/kde /usr/local/kde"

	AC_ARG_WITH(kde,
                [  --with-kde=DIR     Set KDE base directory []],
                tst_kde_dir="${withval}")

	if test "${tst_kde_dir}" != "yes" && test "${tst_kde_dir}" != ""; then
		AC_MSG_CHECKING([for KDE in ${tst_kde_dir}])
		AC_EGREP_HEADER(configureWm,${tst_kde_dir}/include/kwm.h,
		kde_dir=${tst_kde_dir})
		if test "$kde_dir" != "no"; then
			AC_MSG_RESULT("yes")
		else
			AC_MSG_RESULT("no")
		fi
	fi

	if test "${kde_dir}" = "no"; then
		for tst_kde_dir in ${kde_search}; do
			if test "${kde_dir}" = "no"; then
				AC_MSG_CHECKING([for KDE in ${tst_kde_dir}])
				AC_EGREP_HEADER(configureWm,${tst_kde_dir}/include/kwm.h,
				kde_dir=${tst_kde_dir})
				if test "$kde_dir" != "no"; then
					AC_MSG_RESULT("yes")
					continue
				else
					AC_MSG_RESULT("no")
				fi
			fi
		done
	fi

	if test "$kde_dir" != "no" ; then
		KDE=1
		AC_DEFINE_UNQUOTED(KDE,1)
	else
		AC_MSG_RESULT("KDE-Dir not found. Run \"configure --with-kde=DIR\"")
		kde_dir=""
	fi
	KDE_DIR="$kde_dir"
	AC_DEFINE_UNQUOTED(KDE_DIR,"$kde_dir")
	AC_SUBST(KDE_DIR)
])
