/********************************************************************
 * lib/db_util.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: db_util.h,v 1.1 1999/12/30 21:04:17 root Exp root $
 *
 ********************************************************************/
 
#ifndef __DB_UTIL_H
#define __DB_UTIL_H

#ifdef DB_POSTGRES
#include <libpq-fe.h>
#include <libpq-int.h>
#define  DB_CONN	PGconn
#define  DB_RES		PGresult*
#define  DB_CLOSE(x)	(PQfinish(x))
#define  DB_ERR(x)	(PQerrorMessage(x))
#define  DB_EXEC(x,y)	(PQexec(x,y))
#define  DB_CHKRES(x)	(x == NULL)
#define  DATESTRING	"'%04d-%02d-%02d'"
#define  DB_DATE_FIRST(d,m,y)	(y)
#define  DB_DATE_SECND(d,m,y)	(m)
#define  DB_DATE_THIRD(d,m,y)	(d)
#define  DB_END_C	';'
#endif

#ifdef DB_MYSQL
#include <mysql.h>
#define  DB_CONN	MYSQL
#define  DB_RES		int
#define  DB_CLOSE(x)	(mysql_close(x))
#define  DB_ERR(x)	(mysql_error(x))
#define  DB_EXEC(x,y)	(mysql_query(x,y))
#define  DB_CHKRES(x)	(x != 0)
#define  DATESTRING	"'%04d.%02d.%02d'"
#define  DB_DATE_FIRST(d,m,y)	(y)
#define  DB_DATE_SECND(d,m,y)	(m)
#define  DB_DATE_THIRD(d,m,y)	(d)
#define  DB_END_C	' '
#endif

#define CALLDB_NAME     "maks_db"

void	exit_nicely(DB_CONN *conn);
void	close_DB(DB_CONN *conn);
int	exec_DB(DB_CONN *conn, char *command);
DB_CONN	*open_DB(char *database);

#endif  __DB_UTIL_H
