/* ******************************************************************
 * AnlPort.cpp
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id$
 *
 * ******************************************************************/

#include <stdio.h>
#include <string>
#include <iostream>
#include <vector>

#include <AnlPort.h>


AnlPort::AnlPort(const vector<BYTE>& data)
{
	_index = data[1];
	_mode = data[2];
}

AnlPort::~AnlPort()
{
}

const char* AnlPort::GetTypName(unsigned int typ) const
{
	if (!typ) return "Tot";
	switch(typ & CTI_S0_PORT_DIR_MASK) {
		case CTI_S0_PORT_DIR_INTERN:
			return "Int";
		case CTI_S0_PORT_DIR_EXTERN:
			return "Amt";
		case CTI_S0_PORT_DIR_QUER:
			return "Lnk";
	}

	return "Undefined";
}

int AnlPort::Mode() const
{
	return(_mode);
}

int AnlPort::isDead() const
{
	return(_mode == 0);
}

int AnlPort::isIntern() const
{
	return((_mode & CTI_S0_PORT_DIR_MASK) == 0);
}

int AnlPort::isExtern() const
{
	return((_mode & CTI_S0_PORT_DIR_EXTERN) == CTI_S0_PORT_DIR_EXTERN);
}

int AnlPort::isQuer() const
{
	return((_mode & CTI_S0_PORT_DIR_QUER) == CTI_S0_PORT_DIR_QUER);
}

int AnlPort::Idx() const
{
	return(_index);
}

ostream& operator<< ( ostream& strm , const AnlPort& info) {

    strm << "Index: " << info.Idx() << '\t';
    strm << "PortTyp: " << info.GetTypName(info.Mode()) << '\t';
    return strm;
}
