/* ******************************************************************
 * AnlPort.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id$
 *
 * ******************************************************************/

#ifndef ANLPORT_H_
#define ANLPORT_H_

#ifndef ostream
#include <iostream>
#endif

#ifndef vector
#include <vector>
#endif

#ifndef BYTE
#define BYTE unsigned char
#endif

#define CTI_PORT_NICHT_KONFIGURIERT         0x00

#define CTI_S0_PORT_DIR_INTERN              0x00
#define CTI_S0_PORT_DIR_EXTERN              0x40
#define CTI_S0_PORT_DIR_QUER                0x80
#define CTI_S0_PORT_DIR_MASK                0xC0
                
#define CTI_S0_PORT_MODE_PTP                0x00
#define CTI_S0_PORT_MODE_PTMP               0x10
#define CTI_S0_PORT_MODE_PTMP_NET3          0x30

#define CTI_S0_PORT_MODE_NET3               0x20

#define CTI_S0_PORT_PROT_EDSS1              0x02
#define CTI_S0_PORT_PROT_STIMULUS           0x04
#define CTI_S0_PORT_PROT_STIMULUS_EDSS1     0x06
#define CTI_S0_PORT_PROT_QSIG               0x08
#define CTI_S0_PORT_PROT_CORNET_T           0x0c

#define CTI_S0_PORT_WAHL_MSN                0x00
#define CTI_S0_PORT_WAHL_DDI                0x01

class AnlPort {
public:
	AnlPort(const vector<BYTE>&);
	~AnlPort();

	int		Idx() const;
	int		Mode() const;
	int		isDead() const;
	int		isIntern() const;
	int		isExtern() const;
	int		isQuer() const;

	const char *GetTypName(unsigned int) const;

	friend ostream& operator<< ( ostream&, const AnlPort&);

	typedef enum {
		S0Amt = 0,
		S0Intern,
		S0Quer,
	};

protected:
	unsigned char   _mode;
	int				_index;

};
#endif ANLPORT_H_
