/* ******************************************************************
 * EPacket.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: EPacket.h,v 1.4 2000/01/08 10:18:27 root Exp root $
 *
 * ******************************************************************/

#ifndef EPACKET_H_
#define EPACKET_H_

#ifndef BYTE
#define BYTE unsigned char
#endif

#include <iostream>
#include <vector>

class ESPMsgHdr {

public:

	// Contructors & Destructors
	ESPMsgHdr(BYTE flgn, BYTE anlg, BYTE grp, BYTE elem, const vector<BYTE> &buf);
	ESPMsgHdr(const BYTE *buf);
	ESPMsgHdr() {};

	bool	isError();
	bool	isAnswer();
	void	read( int fd );
	void	write( int fd );
 
	BYTE	folgenummer;
	BYTE	anlage;
	BYTE	gruppe;
	BYTE	element;
 	vector<BYTE>	data;
	
	friend	ostream& operator<< ( ostream& strm , const ESPMsgHdr& ep);
};

#endif  EPACKET_H_





