#include <stdio.h>
#include <iostream.h>

#include <kapp.h>
#include <kconfig.h>
#include <qstring.h>
#include <Login.moc>

KConfig *kConf;

/***************************************************************
 * Show Login-Dialog
 ***************************************************************/
Login::Login(QWidget* _parent=0, const char* _name=0, bool _modal=true, WFlags _f=0) 
	: QDialog(_parent, _name, _modal, _f)
{

	frame = new QFrame(this);
	nameL = new QLabel("User:",frame);
	nameE = new QLineEdit(frame);
	passL = new QLabel("Passwort:",frame);
	passE = new QLineEdit(frame);
	hostL = new QLabel("Host:",frame);
	hostE = new QLineEdit(frame);
	portL = new QLabel("Port:",frame);
	portE = new QLineEdit(frame);
	okB = new QPushButton("OK", this);
	cancelB = new QPushButton("Abbrechen", this);


	frame->setFrameStyle(QFrame::Panel | QFrame::Sunken);
	frame->setLineWidth(1);
	nameL->setAlignment(AlignLeft);
	passL->setAlignment(AlignLeft);
	hostL->setAlignment(AlignLeft);
	portL->setAlignment(AlignLeft);

	passE->setEchoMode(QLineEdit::Password);

	nameL->resize(50,20);
	passL->resize(50,20);
	hostL->resize(50,20);
	portL->resize(50,20);
	okB->resize(80,20);
	cancelB->resize(80,20);

	frame->move(5,5);
	frame->resize(300,150);

	nameL->move(5, 5);

	nameE->move(nameL->frameGeometry().right() + 5, 5);
	nameE->resize(frame->width() - 65, 20);

	passL->move(5, nameE->frameGeometry().bottom() + 5);

	passE->move(passL->frameGeometry().right() + 5, nameE->frameGeometry().bottom() + 5);
	passE->resize(nameE->width() ,nameE->height());

	hostL->move(5, passE->frameGeometry().bottom() + 5);

	hostE->move(hostL->frameGeometry().right() + 5, passE->frameGeometry().bottom() + 5);
	hostE->resize(nameE->width() ,nameE->height());

	portL->move(5, hostE->frameGeometry().bottom() + 5);

	portE->move(portL->frameGeometry().right() + 5, hostE->frameGeometry().bottom() + 5);
	portE->resize(nameE->width() ,nameE->height());

	frame->resize(300, portE->frameGeometry().bottom() + 5);

	okB->move(frame->frameGeometry().left() + 8, frame->frameGeometry().bottom() + 8);
	
	cancelB->move(frame->frameGeometry().right() - 8 - cancelB->width(), frame->frameGeometry().bottom() + 8);

	resize(frame->width() + 10, cancelB->frameGeometry().bottom() + 8);

	okB->setDefault(true);
	QObject::connect(okB,     SIGNAL(clicked()), SLOT(accept()));
	QObject::connect(cancelB, SIGNAL(clicked()), SLOT(reject()));

	kConf = KApplication::getKApplication()->getConfig();
	kConf->setGroup(KApplication::getKApplication()->appName());
	readPrefs();
}

/***************************************************************
 * Free Space
 ***************************************************************/
Login::~Login()
{
	writePrefs();
}

void Login::readPrefs()
{
	__name = strdup(kConf->readEntry("USER", "nobody").data());
	__host = strdup(kConf->readEntry("HOST", "localhost").data());
	__port = kConf->readNumEntry("PORT", 2001);

	nameE->setText(__name);
	hostE->setText(__host);

	QString a;
	a.sprintf("%d",__port);

	portE->setText(a);
}

void Login::writePrefs()
{
	if (result() == Accepted) {
		kConf->writeEntry("USER", nameE->text());
		kConf->writeEntry("HOST", hostE->text());
		kConf->writeEntry("PORT", portE->text());
	}
}

const char *Login::User() const
{
	return(nameE->text());
}

const char *Login::Host() const
{
	return(hostE->text());
}

const char *Login::Pass() const
{
	return(passE->text());
}

int Login::Port() const
{
	QString a(portE->text());

	return(a.toInt());
}
