/* ******************************************************************
 * MsgHandlerQt.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: MsgHandlerQt.h,v 1.2 2000/01/08 10:18:27 root Exp root $
 *
 * ******************************************************************/

#ifndef MSGHANDLERQT_H_
#define MSGHANDLERQT_H_

#ifndef Q_OBJECT
#include <qobject.h>
#endif

#ifndef KSocket
#include <ksock.h>
#endif

#ifndef ESPMsgHdr
#include "EPacket.h"
#endif

#ifndef MsgHandler
#include "MsgHandler.h"
#endif

class MsgHandlerQt : public QObject , public MsgHandler {

	Q_OBJECT

public:
	// Contructors & Destructors
	MsgHandlerQt(const char *, const int, const char *, const char *, const char *, const BYTE, const BYTE);
	~MsgHandlerQt(){delete conn;};

	// Packet Handler
	void msg_Emitter(ESPMsgHdr *);
	
	int socket(){return conn->socket();};
	void processEvents();

protected:
	KSocket* conn;

	void sendfailMsg(char *msg, int fatal);
	void sendrdyMsg(ESPMsgHdr* ep){emit rdyMsg(ep);};

public slots:
	void slotHandle();
	void slotClose();

signals:

	void espMsg(ESPMsgHdr *);
	void anlMsg(ESPMsgHdr *);
	void porMsg(ESPMsgHdr *);
	void gebMsg(ESPMsgHdr *);
	void orgMsg(ESPMsgHdr *);
	void tlnMsg(ESPMsgHdr *);
	void auxMsg(ESPMsgHdr *);
	void staMsg(ESPMsgHdr *);
	void offMsg(ESPMsgHdr *);
	void vbgMsg(ESPMsgHdr *);
	void evtMsg(ESPMsgHdr *);
	void tstMsg(ESPMsgHdr *);
	void fabMsg(ESPMsgHdr *);

	void rdyMsg(ESPMsgHdr *);

	void failMsg(MsgHandlerQt*);

};

#endif MSGHANDLERQT_H_

