/* ******************************************************************
 * NGNotifier.h
 * Part of maKs
 * Copyright Chris Benndorf, 1998
 * Released under GNU Public Library License
 * Best readeable with ":set tabstop=4"
 *
 * $Id: NGNotifier.h,v 1.1 2000/01/08 10:18:27 root Exp $
 *
 * ******************************************************************/

#ifndef NGNOTIFIER_H_
#define NGNOTIFIER_H_

#include <sigc++/signal_system.h>

#ifdef SIGC_CXX_NAMESPACES
using namespace std;
using namespace SigC;
#endif

class NGNotifier : public Object {
	public:
		NGNotifier(int, int = READ, bool = true);
		NGNotifier(const NGNotifier&);
		~NGNotifier();

		int			getTyp()			{ return ntfytyp; }
		const int	decriptor()			{ return _fd; }
		void		enable()			{ enabled = true; }
		void		disable()			{ enabled = false; }
		void		setEnabled(bool x)	{ enabled = x; }
		void		setConnected(bool x){ connected = x; }

		enum {
			READ,
			WRITE,
			EXCEPTION
		};

		bool operator== (const NGNotifier& b) const { return ((ntfytyp == b.ntfytyp) && (_fd == b._fd)); }
		bool operator!= (const NGNotifier& b) const { return ((ntfytyp != b.ntfytyp) || (_fd != b._fd)); }
		bool operator<  (const NGNotifier& b) const { return (_fd < b._fd); }
		const NGNotifier& operator= (const NGNotifier&);

		Signal1<void,int> activated; // void activated(int fd);

	protected:

		int		_fd;
		bool	enabled;
		bool	connected;
		int		ntfytyp;
};

#endif NGNOTIFIER_H_
